const Sequelize = require('sequelize');
const moment = require('moment')
const Op = Sequelize.Op;


const dbAddress = process.env.DEBUG === 'true' ? process.env.HOST_Local : process.env.HOST_Server;
const dbPassword = process.env.DEBUG === 'true' ? 'root' : process.env.DB_PASS_SERVER;


const sequelize = new Sequelize('accounting', 'root',  dbPassword, {
    define: {
        charset: 'utf8',
        charset: 'utf8',
        collate: 'utf8_general_ci'
    },
    host:  dbAddress,
    dialect: 'mysql',
    logging: false,


    operatorsAliases: false
});


const User = sequelize.define('user', {
    first_name: Sequelize.STRING,
    last_name: Sequelize.STRING,
    pro: {type: Sequelize.BOOLEAN, allowNull: false, defaultValue: false},
    toman_balance: {type: Sequelize.DOUBLE, allowNull: false, defaultValue: 0},
    dollar_balance: {type: Sequelize.DOUBLE, allowNull: false, defaultValue: 0},
    euro_balance: {type: Sequelize.DOUBLE, allowNull: false, defaultValue: 0},
    lir_balance: {type: Sequelize.DOUBLE, allowNull: false, defaultValue: 0},
    aed_balance: {type: Sequelize.DOUBLE, allowNull: false, defaultValue: 0},


});


const Admin = sequelize.define('admin', {
    teleid: Sequelize.INTEGER,
    status: Sequelize.INTEGER,
    data: Sequelize.STRING


});


const Request = sequelize.define('request', {
    user_request: Sequelize.INTEGER,
    fee: Sequelize.DOUBLE,
    count: Sequelize.DOUBLE,
    unit: Sequelize.STRING,
    toUnit: Sequelize.STRING,
    is_today: Sequelize.BOOLEAN,
    file_id: Sequelize.STRING,
    type: Sequelize.STRING,

});


async function createRequest(data) {

    let mRequest = await Request.create({
        user_request: data.user,
        fee: data.fee,
        count: data.count,
        unit: data.vahed,
        file_id: data.file_id,
        type:data.action,
        toUnit: data.to,
        is_today: true

    })
    return mRequest;


}

async function getAllUsers() {


    return await User.findAll({
        raw: true
    })
}

async function getRequestByDate(userId, date) {


    return await Request.findAll({
        raw: true,
        where: {
            user_request: userId,
            createdAt: {
                [Op.gte]: moment().subtract(date, 'days').toDate()
            }

        }
    })
}


async function updateData(msg, data) {
    return await Admin.update(
        {
            data: data,


        },
        {where: {teleid: typeof msg.chat !== 'undefined' ? msg.chat.id : msg.message.chat.id}})

}

async function updateStatus(msg, status) {
    return await Admin.update(
        {
            status: status,


        },
        {where: {teleid: typeof msg.chat !== 'undefined' ? msg.chat.id : msg.message.chat.id}})

}

async function findUser(id) {
    return await User.findOne({raw: true, where: {id: id}})
}

async function findAdmin(msg) {
    return await Admin.findOne({
        raw: true,
        where: {teleid: typeof msg.chat !== 'undefined' ? msg.chat.id : msg.message.chat.id}
    })




}

async function findRequest(id) {
    return await Request.findOne({
        raw: true,
        where: {id: id}
    })
}


module.exports = {

    getAllUsers: getAllUsers,
    findUser: findUser,
    updateData: updateData,
    findAdmin: findAdmin,
    updateStatus: updateStatus,
    createRequest: createRequest,
    getRequestByDate: getRequestByDate,
    findRequest: findRequest
};
